﻿package {
	import flash.display.MovieClip;
	import flash.display.DisplayObjectContainer;
	import flash.events.Event;
	import flash.display.Loader;
	import flash.net.URLRequest;
	import flash.geom.Matrix;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	
	import fl.transitions.*;
 	import fl.transitions.easing.*;
  
 

	public class ImgLoader {

		private var img_loader:Loader;

		private var img_path:String;

		private var img_target:DisplayObjectContainer;

		private var cont_w:Number;
		private var cont_h:Number;
		
		private var animate:Boolean;

		public function ImgLoader(_tg:DisplayObjectContainer,anim:Boolean = false,_w:Number=0,_h:Number=0) {
			animate = anim;
			img_target = _tg;
			img_loader = new Loader();
			img_loader.contentLoaderInfo.addEventListener(Event.COMPLETE,dataLoaded);
			if (_w==0) {
				cont_w = _tg.width;
			} else {
				cont_w = _w;
			}
			if (_h==0) {
				cont_h = _tg.height;
			} else {
				cont_h = _h;
			}
		}
		public function loadImg(_path:String):void {
			img_path = _path;
			var req:URLRequest = new URLRequest(img_path);
			img_loader.load(req);
		}
		private function dataLoaded(evt:Event):void {

			var ln:Number = 0;
			var scaling:Number=0;

			if (cont_w>cont_h) {
				scaling = cont_h/img_loader.content.height;
			} else {
				scaling = cont_w/img_loader.content.width;
			}
			var matr:Matrix = new Matrix();
			matr.scale(scaling,scaling);
			var bitmap:BitmapData = new BitmapData(img_loader.content.width*scaling,img_loader.content.height*scaling,false);
			bitmap.draw(img_loader.content,matr);

			var bmp:Bitmap = new Bitmap(bitmap,"auto",true);
			bmp.x = (cont_w-bmp.width)/2;
			bmp.y = (cont_h-bmp.height)/2;
			bmp.name = "_img";

			if (img_target.getChildByName("_img")) {
				img_target.removeChild(img_target.getChildByName("_img"));
			}
			img_target.addChild(bmp);
			if(animate){
				TransitionManager.start(img_target as MovieClip, {type:Fade, direction:Transition.IN, duration:3, easing:Regular.easeOut});
			}

		}
	}
}